Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0045301
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] 07. Sales managementmajoralways2020-10-26 15:472021-05-18 13:57
ReporterngarciaView Statuspublic 
Assigned Tocberner 
PriorityurgentResolutionfixedFixed in VersionPR21Q1
StatusclosedFix in branchFixed in SCM revision
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned ToAugustoMauch
Web browser
ModulesCore
Regression levelProduction - Confirmed Stable
Regression date2019-08-30
Regression introduced in release3.0PR19Q3
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0045301: Sales Order header can be saved without Invoice Address although it is mandatory

DescriptionSales Order header can be saved without Invoice Address although it is mandatory.

Business Partner window also has a mandatory field in a "More Information" field group, it can be saved if empty and More Information is collapsed.
Steps To ReproduceAs group admin role:
   Create a customer
   Add a location to it
   Set it as Invoicing Address = 'N'

Create a Sales Order header
Do not expand the More Information section
Set the required fields (except Invoice Address)
Click on Lines tab and check the header is saved and it shouldn't
Open the More Information section
Click on Lines tab
Check the following error is shown:
   One or more fields contain illegal values, check the errors for each field.
This is correct

It is also reproducible in Business Partner window
- Create a new BP
- Open More Information collapsed field group
- Empty "Credit Line Limit" field
- Close More Information field group(collapse it)
- Click on the Customer subtab
- Check that the BP was saved, although the "Credit Line Limit" has invalid information.
Proposed SolutionValidate also hidden fields.
TagsNo tags attached.
Attached Files

- Relationships Relation Graph ] Dependency Graph ]
depends on backport 0045331PR20Q4 closedcberner Sales Order header can be saved without Invoice Address although it is mandatory 
depends on backport 0045332PR20Q3.2 closedcberner Sales Order header can be saved without Invoice Address although it is mandatory 
depends on backport 0045333PR20Q2.3 closedcberner Sales Order header can be saved without Invoice Address although it is mandatory 
causes defect 0046681 closedcberner If a tab has a field for the id of the entity, it is no longer possible to create a new record in form view 

-  Notes
(0123959)
hgbot (developer)
2020-10-27 18:12

Merge Request created: https://gitlab.com/openbravo/product/openbravo/-/merge_requests/204 [^]
(0123995)
cberner (developer)
2020-10-29 10:15
edited on: 2020-10-29 10:50

This issue is considered a regression from user perspective. The issue has always been there, but it was made visible starting from 19Q3 in Business Partner windows, because mandatory fields were moved from the main Field Group to a collapsed field group.

In Sales Order is also reproducible in 19Q2 because this mandatory field was already in "More Information" field group, we keep this issue as a regression in 19Q3, although we're not sure the actual version when Sales Order field "Invoice Address" was moved to the collapsed field group.

(0124057)
hgbot (developer)
2020-10-30 12:36

Merge request merged: https://gitlab.com/openbravo/product/openbravo/-/merge_requests/204 [^]
(0124058)
hgbot (developer)
2020-10-30 12:36

Directly closing issue as related merge request is already approved.

Repository: https://gitlab.com/openbravo/product/openbravo [^]
Changeset: 74ec2cdad81aba152fc7a704384cc96836dabde9
Author: Cristian Berner <cristian.berner@openbravo.com>
Date: 2020-10-30T11:28:14+00:00
URL: https://gitlab.com/openbravo/product/openbravo/-/commit/74ec2cdad81aba152fc7a704384cc96836dabde9 [^]

Fixes ISSUE-45301: Record can be saved with missing mandatory field data

If a mandatory field in a collapsed field group had no value or invalid
values, the record could be saved by the auto-save when changing focus
to a child tab.

The approach taken here is to also validate hiddenFields that are not
present because of being in a collapsed field group.

form.validate method can be found in smartclient DynamicForm and it
accepts as first argument a boolean indicating to validate or no hidden
fields, it is now set to true on ob-view-form, fixing this issue.

---
M modules/org.openbravo.client.application/web/org.openbravo.client.application/js/form/ob-view-form.js
---
(0128320)
hgbot (developer)
2021-05-18 13:57

Repository: https://gitlab.com/openbravo/product/openbravo [^]
Changeset: 9ba983cd4aa5aea143ded1d5f48e9a872ba21641
Author: Cristian Berner <cristian.berner@openbravo.com>
Date: 2021-05-18T11:54:46+00:00
URL: https://gitlab.com/openbravo/product/openbravo/-/commit/9ba983cd4aa5aea143ded1d5f48e9a872ba21641 [^]

Fixes ISSUE-46681: Not possible to create a new record in form view if id is present in tab

This was due to how validation is handled in form, to avoid ISSUE-45301
a validateHiddenFields flag has been set to true to validate all hidden
fields that may be present in the form but under collapsed field groups.
This also checks all hidden fields, for example in this case identifier.
Which on new records is always undefined, until the record is saved and
an id is received.

To fix this, a check is done at validateField level, if the field is hidden and not displayed, validation will be skipped.
An alternative would be to only validate displayed fields at this level,
but this may be more prone to errors.

---
M modules/org.openbravo.client.application/web/org.openbravo.client.application/js/form/ob-view-form.js
---
(0128323)
hgbot (developer)
2021-05-18 13:57

Repository: https://gitlab.com/openbravo/product/openbravo [^]
Changeset: 75dbb51faa05fb06429dfdf960d60405560c744d
Author: Cristian Berner <cristian.berner@openbravo.com>
Date: 2021-05-18T09:59:32+02:00
URL: https://gitlab.com/openbravo/product/openbravo/-/commit/75dbb51faa05fb06429dfdf960d60405560c744d [^]

Fixes ISSUE-46702: Not possible to create a new record in form view if id is present in tab

This was due to how validation is handled in form, to avoid ISSUE-45301
a validateHiddenFields flag has been set to true to validate all hidden
fields that may be present in the form but under collapsed field groups.
This also checks all hidden fields, for example in this case identifier.
Which on new records is always undefined, until the record is saved and
an id is received.

To fix this, a check is done at validateField level, if the field is hidden and not displayed, validation will be skipped.
An alternative would be to only validate displayed fields at this level,
but this may be more prone to errors.

---
M modules/org.openbravo.client.application/web/org.openbravo.client.application/js/form/ob-view-form.js
---
(0128326)
hgbot (developer)
2021-05-18 13:57

Repository: https://gitlab.com/openbravo/product/openbravo [^]
Changeset: 3f52e5ace10eb872561509df5e6f822d698262d4
Author: Cristian Berner <cristian.berner@openbravo.com>
Date: 2021-05-18T10:04:56+02:00
URL: https://gitlab.com/openbravo/product/openbravo/-/commit/3f52e5ace10eb872561509df5e6f822d698262d4 [^]

Fixes ISSUE-46685: Not possible to create a new record in form view if id is present in tab

This was due to how validation is handled in form, to avoid ISSUE-45301
a validateHiddenFields flag has been set to true to validate all hidden
fields that may be present in the form but under collapsed field groups.
This also checks all hidden fields, for example in this case identifier.
Which on new records is always undefined, until the record is saved and
an id is received.

To fix this, a check is done at validateField level, if the field is hidden and not displayed, validation will be skipped.
An alternative would be to only validate displayed fields at this level,
but this may be more prone to errors.

---
M modules/org.openbravo.client.application/web/org.openbravo.client.application/js/form/ob-view-form.js
---
(0128329)
hgbot (developer)
2021-05-18 13:57

Repository: https://gitlab.com/openbravo/product/openbravo [^]
Changeset: 9ab49a024670d8a4823a686b8f5a3de01a12770c
Author: Cristian Berner <cristian.berner@openbravo.com>
Date: 2021-05-18T10:50:56+02:00
URL: https://gitlab.com/openbravo/product/openbravo/-/commit/9ab49a024670d8a4823a686b8f5a3de01a12770c [^]

Fixes ISSUE-46684: Not possible to create a new record in form view if id is present in tab

This was due to how validation is handled in form, to avoid ISSUE-45301
a validateHiddenFields flag has been set to true to validate all hidden
fields that may be present in the form but under collapsed field groups.
This also checks all hidden fields, for example in this case identifier.
Which on new records is always undefined, until the record is saved and
an id is received.

To fix this, a check is done at validateField level, if the field is hidden and not displayed, validation will be skipped.
An alternative would be to only validate displayed fields at this level,
but this may be more prone to errors.

---
M modules/org.openbravo.client.application/web/org.openbravo.client.application/js/form/ob-view-form.js
---

- Issue History
Date Modified Username Field Change
2020-10-26 15:47 ngarcia New Issue
2020-10-26 15:47 ngarcia Assigned To => Triage Finance
2020-10-26 15:47 ngarcia Modules => Core
2020-10-26 15:47 ngarcia Triggers an Emergency Pack => No
2020-10-26 15:50 ngarcia Issue Monitored: networkb
2020-10-26 16:09 dmiguelez Assigned To Triage Finance => platform
2020-10-27 10:45 cberner Assigned To platform => cberner
2020-10-27 18:12 hgbot Note Added: 0123959
2020-10-28 09:46 cberner Review Assigned To => AugustoMauch
2020-10-29 10:15 cberner Note Added: 0123995
2020-10-29 10:19 cberner Regression level => Production - Confirmed Stable
2020-10-29 10:19 cberner Regression introduced in release => 3.0PR19Q3
2020-10-29 10:19 cberner Steps to Reproduce Updated View Revisions
2020-10-29 10:19 cberner Proposed Solution updated
2020-10-29 10:20 cberner Regression date => 2019-08-30
2020-10-29 10:49 cberner Description Updated View Revisions
2020-10-29 10:50 cberner Note Edited: 0123995 View Revisions
2020-10-29 10:56 cberner Status new => scheduled
2020-10-30 12:36 hgbot Note Added: 0124057
2020-10-30 12:36 hgbot Resolution open => fixed
2020-10-30 12:36 hgbot Status scheduled => closed
2020-10-30 12:36 hgbot Fixed in Version => PR21Q1
2020-10-30 12:36 hgbot Note Added: 0124058
2021-05-14 15:09 dmitry_mezentsev Relationship added causes 0046681
2021-05-18 13:57 hgbot Note Added: 0128320
2021-05-18 13:57 hgbot Note Added: 0128323
2021-05-18 13:57 hgbot Note Added: 0128326
2021-05-18 13:57 hgbot Note Added: 0128329


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker